import ddf.minim.*;
import ddf.minim.ugens.*;
 
Minim minim;
AudioOutput out;
ToneInstrument myNote;
 
int note = 350;
 
void setup(){
  size(400, 400, P2D);
 
  minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO, 1000);
 minim.loadFile("note.mp3");
}
 
void draw(){
  background( 255 );
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 0 + out.left.get(i)*0, x2, 50 + out.left.get(i+1)*50);
    
  } 
 
 stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 100 + out.left.get(i)*100, x2, 50 + out.left.get(i+1)*50);
    
  }  
  
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 200 + out.left.get(i)*200, x2, 50 + out.left.get(i+1)*50);
    
  }  
  
  
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 300 + out.left.get(i)*300, x2, 50 + out.left.get(i+1)*50);
    
  }  
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 400 + out.left.get(i)*400, x2, 50 + out.left.get(i+1)*50);
    
  }  
 
  
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 500 + out.left.get(i)*500, x2, 50 + out.left.get(i+1)*50);
    
  }  
  
  stroke(0);
  for( int i = 0; i < out.bufferSize() - 1; i++ ){
    float x1  =  map( i, 0, out.bufferSize(), 0, width );
    float x2  =  map( i+1, 0, out.bufferSize(), 0, width );
    rect( x1, 600 + out.left.get(i)*600, x2, 50 + out.left.get(i+1)*50);
    
  }  

}
 
void mousePressed(){
  
  out.playNote(0.f, 2, note );  
}
 
void keyPressed(){
  if (key == 'M' || key == 'm') note++;
  else if (key == 'N' || key == 'n') note--;
}
 
class ToneInstrument implements Instrument{
  Oscil sineOsc, lFOOsc;
  Balance balance;
 
  ToneInstrument(float frequency, float amplitude, float lfoFrequency, float lfoAmplitude){
    sineOsc = new Oscil(frequency, amplitude, Waves.SINE);
    lFOOsc = new Oscil(lfoFrequency, lfoAmplitude, Waves.SINE);
    balance = new Balance( 5 );
    lFOOsc.patch( balance.balance );
 
    sineOsc.patch( balance );
  }
  void noteOn(float dur){
    balance.patch(out);
  }
 
 
  void noteOff(){
    balance.unpatch(out);
  }
}